{*********************************************************************}
{*                                                                   *}
{*                    Vitus CRT extensions                           *}
{*                                                                   *}
{*           Copyright (c) by Vitus B.Wagner,1993                    *}
{*                                                                   *}
{*********************************************************************}
{$I-,S-,R-,V-,B-,A+}
Unit VCRTEXt;
interface
Uses VCRT;
 Const SingleFrame='ڿٳ';
       DoubleFrame='ɻȼ';
 Type FrameType=Array[0..5] of char;
      MenuItemType=Function(ItemNo:Integer):String;
 Var InverseAttr:Byte;
     Frame:FrameType;
 {Draws frame around specified window}
 Procedure FrameWindow(X1,y1,x2,y2:Byte);
 {fills window with spaces with current attribures even in EGA/VGA graphic modes}
 {Saves window content and places pointer to it in SavePtr.
  If not successiful, returns nil. Works in text modes only }
 Procedure SaveWindow(X1,y1,X2,y2:byte;var SavePtr:Pointer);
 {Restores window content saved by SaveWindow }
 Procedure RestoreWindow(X1,Y1:Byte;Var SavePtr:Pointer);
 {Disposes memory structure, Created by SaveWindow}
 Procedure DisposeWindow(var SavePtr:Pointer);
 {Changes symbol's attributes to InverseAttr in text modes or by XOR
  with InverseAttr in all graphic modes exept CGA HiRes and inverse symbols
  in CGA HiResMode}
 Procedure Inverse(Count:Byte);
 Function ReadScreen(X,Y:Byte):Char;
 Function ReadAttr(X,Y:Byte):Byte;{Works in text mode only}
 {Clipper-Like menu generator}
 Procedure ClearMenu;{Clears all internal data for menu}
 {Adds string to menu}
 Procedure Prompt(S:String;Row,Col:Byte);
 {Allows selection from ClipperLike menu and returns Choice number or 0 if
  Escaped}
 Function Menu:Integer;
 {Allows selection from vertical menu in current window }
 Function VertMenu:Integer;
 {Creates scrollable menu in  current window}
 Function LongMenu(ItemFuns:MenuItemType):Integer;
Implementation
 Procedure FrameWindow(X1,y1,x2,y2:Byte);External;
 {$L VCRTExt}
 Procedure MoveFromScreen(Row,Col,Count:Byte;var Dest);external;
 Procedure MoveToScreen(Row,Col,Count:Byte;Var Src);external;
 Type SaveWindowRec = Record
                       W,H:Byte;
                       Data:Array[0..4799] of word;
                      end;
 Procedure SaveWindow(X1,y1,X2,y2:byte;var SavePtr:Pointer);
 var W,H:Byte;
     i,j:Integer;
     P :^SaveWindowRec absolute SavePtr;
 begin
  ReinitCrt;
  if (X1>X2)or(Y1>Y2) or
  ((Lo(LastMode)>3) and (Lo(LastMode)<>7)) then
   begin
    SavePtr:=Nil;
    Exit;
   end;
   W:=X2-X1+1;
   H:=Y2-Y1+1;
   GetMem(SavePtr,2*Succ(W*h));
   if SavePtr=nil then Exit;
   J:=0;
   For i:=1 to H do
    Begin
     MoveFromScreen(Pred(i+Y1),X1,W,P^.Data[j]);
     Inc(J,W);
    end;
    P^.H:=H;
    P^.W:=W;
 end;
 Procedure RestoreWindow(X1,Y1:Byte;Var SavePtr:Pointer);
 var P:^SaveWindowRec absolute SavePtr;
     I,j:Integer;
 begin
  J:=0;
  if SavePtr=nil then Exit;
  For I:=1 to P^.H do
   begin
    MoveToScreen(Pred(Y1+I),X1,P^.W,P^.Data[j]);
    Inc(J,P^.W);
   end;
 end;
 Procedure DisposeWindow(var SavePtr:Pointer);
 var P:^SaveWindowRec;
 begin
   if P=nil then Exit;
   FreeMem(P,Succ(P^.W*P^.H)*2);
 end;
 Procedure Inverse(Count:Byte);External;
 Function ReadScreen(X,Y:Byte):Char;External;
 Function ReadAttr(X,Y:Byte):Byte;External;
  Const MaxMenuSize=64;
  Type MenuRec = record
                   X,Y,C:Byte;
                 end;
  Var MenuCount:Word;
      MenuAr:Array[1..MaxMenuSize]of MenuRec;
 Procedure ClearMenu;
 begin
  MenuCount:=0;
 end;
 Procedure Prompt(S:String;Row,Col:Byte);
 begin
  if MenuCount=MaxMenuSize then exit;
  inc(MenuCount);
  With MenuAr[MenuCount] do
   begin
    X:=Col;
    Y:=Row;
    C:=Length(S);
   end;
   GotoXY(Col,Row);
    Write(S);
 end;
 Function Menu:Integer;
 begin
 end;
 Function VertMenu:Integer;
 begin
 end;
 Function LongMenu(ItemFuns:MenuItemType):Integer;
 begin
 end;
begin
 ClearMenu;
 Frame:=DoubleFrame;
end.